! *******************************************************************
! *  DATE_EQ compares the incoming extracted data with the          *
! *  given TOUCH_DATA. Result is true if both are equal             *
!                                                                   *
!    The proc needs the static tables MSTR1 and MSTR2 as follows:   *
!    DCL MSTR1 INV CHAR(36) INIT('JANFEBMARAPRMAY ......'           *
!    DCL MSTR2 INV CHAR(36) INIT('JanFebMarAprMay ......'           *
! *******************************************************************

DATE_EQU: PROC ((BUFFER,TOUCH_DATA) CHAR(50)) RETURNS(BIT(1));

 DCL BUFFER_KONV          CHAR(50);

 DCL POS                  FIXED(15);

 DCL MINUTE                CHAR(2); 
 DCL STUNDE                CHAR(2); 
 DCL TAG                   CHAR(2); 
 DCL MONAT                 CHAR(3);
 DCL MONAT_STR2            CHAR(2);
 DCL JAHR                  CHAR(4);

 DCL TOUCH_MINUTE          CHAR(2);
 DCL TOUCH_STUNDE          CHAR(2);
 DCL TOUCH_TAG             CHAR(2);
 DCL TOUCH_MONAT           CHAR(2);
 DCL TOUCH_JAHR            CHAR(4);

 DCL DATEEQ                BIT(1);

 BUFFER_KONV=' ';
 FOR I TO LEN(BUFFER) REPEAT
   CASE BUFFER.CHAR(I)
     ALT (':') BUFFER_KONV.CHAR(I)=':';
     ALT ('0':'9') BUFFER_KONV.CHAR(I)='N';
     ALT ('A':'Z','a':'z') BUFFER_KONV.CHAR(I)='A';
   FIN;
 END;

! ... Isolate time of the day .........................................
 POS  = INSTR(BUFFER_KONV,1,LEN(BUFFER_KONV),'NN:NN:NN',1,8);
 IF POS NE 0 THEN
    STUNDE = MID(BUFFER,POS,POS+1);
    MINUTE = MID(BUFFER,POS+3,POS+4);
 FIN; /* IF POSTION NE 0 THEN */

! ... Try several alternative ways to isolate the date ................

   ! TAG,MONAT UND JAHR HERAUSSCHNEIDEN 1.ALTERNATIVE !
   ! DIESE ALTERNATIVE IST ENTSTANDEN, WEIL ES NETSCAPE NICHT FUER NOETIG HAELT
   ! DIE KOMPLETTE JAHRESANGABE ZU SENDEN, SONDERN NUR DIE LETZTEN BEIDEN ZIFFERN 
   ! DES JAHRES. SPRICH' ANSTELLE VON 1998 SENDET NETSCAPE 98 !! SUPER !

 POS  = INSTR(BUFFER_KONV,1,LEN(BUFFER_KONV),' NN AAA NN ',1,11);
 IF POS NE 0 THEN
    POS = POS +1;
    TAG   = MID(BUFFER,POS,POS+1);
    MONAT = MID(BUFFER,POS+3,POS+5);
    JAHR  ='19';
    JAHR.CHAR(3)  = MID(BUFFER,POS+7,POS+7);
    JAHR.CHAR(4)  = MID(BUFFER,POS+8,POS+8);
    IF TOFIXED(JAHR.CHAR(3)) LT 5 THEN
      JAHR.CHAR(1) = '2'; JAHR.CHAR(2)= '0';
    FIN;

 ELSE      ! If the 1st did not work 

   POS  = INSTR(BUFFER_KONV,1,LEN(BUFFER_KONV),' NN AAA NNNN ',1,13);
   IF POS NE 0 THEN
      POS = POS +1;
      TAG   = MID(BUFFER,POS,POS+1);
      MONAT = MID(BUFFER,POS+3,POS+5);
      JAHR  = MID(BUFFER,POS+7,POS+10);
   FIN; /* IF POSTION NE 0 THEN */

 FIN;

 POS=INSTR(MSTR1,1,36,MONAT,1,3);
 IF POS LE 0 THEN
   POS=INSTR(MSTR2,1,36,MONAT,1,3);
 FIN;

 CONVERT ((POS+2)//3) TO MONAT_STR2 BY F(2);

 IF MONAT_STR2.CHAR(1) == ' ' THEN MONAT_STR2.CHAR(1)='0'; FIN;

 TOUCH_STUNDE:=MID(TOUCH_DATA,1,2);
 TOUCH_MINUTE:=MID(TOUCH_DATA,4,5);
 TOUCH_TAG   :=MID(TOUCH_DATA,11,12);
 TOUCH_MONAT :=MID(TOUCH_DATA,14,15);
 TOUCH_JAHR  :=MID(TOUCH_DATA,17,20);

 #IF MAXILOG 
    PUT 'S: (DTCMP) Client-data min:',MINUTE,' hour:',STUNDE,' day:',TAG,' month:',
         MONAT_STR2,' year:',JAHR 
         TO LOGLINK BY A,A(2),A,A(2),A,A(2),A,A(3),A,A(LEN(JAHR));
 
    PUT 'S: (DTCMP) Server-data min:',TOUCH_MINUTE,' hour:',TOUCH_STUNDE,
        ' day:', TOUCH_TAG,' month:',TOUCH_MONAT,' year:',
         TOUCH_JAHR 
         TO LOGLINK BY A,A(2),A,A(2),A,A(2),A,A(3),A,A(LEN(TOUCH_JAHR));
 #FIN; 
   

   ! HIER KOMMT JETZT DER VERGLEICH ZWISCHEN DEM DATUM, DAS UNS DER CLIENT IM 
   ! IF-MODIFIED-SINCE GESENDET HAT, UND DEM DATUM, DAS UNS DAS FILESYSTEM 
   ! LIEFERT. DIESES DATUM ZEIGT AN, WANN DIE DATEI ZUM LETZEN MAL GEAENDERT
   ! WORDEN IST. WENN DAS DATUM NICHT UNTERSCHIEDLICH IST, WIRD IN DIE VARIABLE
   ! METHOD_OR_ERROR EIN "NOT-MODIFIED" EINGETRAGEN. DIES HAT ZUR FOLGE, DAS DER
   ! HEADER DANN EIN NOT-MODIFIEDHEADER AN DEN CLIENT SENDET UND DIE DATEI DANN
   ! NICHT MEHR VON SENDFILE GESENDET WIRD. WENN DAS DATUM UNTERSCHIEDLICH IST,
   ! DANN WIRD NICHTS IN METHOD_OR_ERROR EINGETRAGEN, UND DIE DATEI WIRD DANN 
   ! EINFACH GESENDET, EGAL OB SIE AELTER ODER JUENGER IST !!!   


 DATEEQ =      (TOUCH_MINUTE == MINUTE)
         AND   (TOUCH_STUNDE == STUNDE)
         AND   (TOUCH_TAG    == TAG)
         AND   (TOUCH_MONAT  == MONAT_STR2) 
         AND   (TOUCH_JAHR   == JAHR);

 
 #IF MAXILOG
   IF DATEEQ THEN
     WRITE 'S: (DTCMP) Result: Not modified' TO LOGLINK;
   ELSE  
     WRITE 'S: (DTCMP) Result: Modified' TO LOGLINK;
   FIN;
 #FIN

 RETURN(DATEEQ);

END;



