! *******************************************************************
! * FileErr gibt zu dem auftretenden Fehler des Filemanagers        *
! * die Fehlermeldung im Klartext aus.                              *
! *******************************************************************

FileErr:PROC(ERROR FIXED (15),TY DATION OUT ALPHIC IDENT);

 DCL VOIDPTR REF INV STRUCT[];
 DCL C255PTR REF INV CHAR(255);
 DCL TXLEN FIXED;

  WRITE ''\0D0A\'Filesystem Error :' TO TY;

  VOIDPTR=NIL;

  CASE ERROR
    ALT (1)  VOIDPTR = 'END-OF-FILE.';
    ALT (2)  VOIDPTR = 'READ ERROR.';
    ALT (7)  VOIDPTR = 'TIME-OUT.';
    ALT (8)  VOIDPTR = '# of SKIPS negative.';
    ALT (9)  VOIDPTR = '# of X or PAGE negative.';
    ALT (11) VOIDPTR = 'Data type and FORMAT do not match.';
    ALT (14) VOIDPTR = 'Device not suited for this operation.';
    ALT (15) VOIDPTR = 'Path-list error.';
    ALT (33) VOIDPTR = 'Data address error.';
    ALT (34) VOIDPTR = 'Track 00 not found.';
    ALT (35) VOIDPTR = 'Aborted command error.';       
    ALT (36) VOIDPTR = 'Controller Fault.';
    ALT (37) VOIDPTR = 'ID-field not found.';
    ALT (38) VOIDPTR = 'CRC error in ID or Data.';
    ALT (39) VOIDPTR = 'Uncorrectable data error.';
    ALT (40) VOIDPTR = 'Bad Block Found.';
    ALT (41) VOIDPTR = 'Drive not ready.';
    ALT (42) VOIDPTR = 'Device write-protected.';
    ALT (43) VOIDPTR = 'Disk changed.';
    ALT (44) VOIDPTR = 'Drive not present.';
    ALT (45) VOIDPTR = 'Disk format unknown.';
    ALT (46) VOIDPTR = 'Directory active.';
    ALT (47) VOIDPTR = 'Path list error.';
    ALT (48) VOIDPTR = 'Directory in system.';
    ALT (49) VOIDPTR = 'Directory not found.';
    ALT (50) VOIDPTR = 'File not found.';
    ALT (51) VOIDPTR = 'Disk full error.';
    ALT (52) VOIDPTR = 'Filesystem not consistent.';
    ALT (53) VOIDPTR = 'Drive busy (raw mode).';
    ALT (54) VOIDPTR = 'File in system.';
    ALT (55) VOIDPTR = 'Root directory or disk full.';
    ALT (56) VOIDPTR = 'No DOS format.';
    ALT (57) VOIDPTR = 'Fatal error in block 0.'; 
    ALT (58) VOIDPTR = 'Exclusive open (no access right).';
    OUT      VOIDPTR = 'No info available for this error.';
  FIN;

  IF VOIDPTR ISNT NIL THEN
    C255PTR = VOIDPTR;
    TXLEN = INSTR(C255PTR,1,255,'.',1,1);
    PUT C255PTR TO TY BY A(TXLEN),SKIP;
    AFTER 1 SEC RESUME;    
  FIN;

END;

