! *******************************************************************
! * In dieser Includedatei sind die Prozeduren zusammengefasst, die *
! * zum Erstellen eines HTTP-Headers gehoren.                       *
! *-----------------------------------------------------------------*
! * Autor :  W. Gerth  April 20, 2000 (Vorlage L. Schreiner)        *
! *******************************************************************
! *LAMO-EXP creates strings for procs LAST_MODIFIED and EXPIRES     *
! *******************************************************************

LAMO_EXP: PROC(DATA CHAR(100),LASTMODDATE CHAR(10),LASTMODTIME CHAR(8))
                   RETURNS(CHAR(100));

    DCL Y                     CHAR(100);    ! internal buffer
    DCL TAG_FIXED15           FIXED(15);
    DCL MONAT_FIXED15         FIXED(15);
    DCL JAHR_FIXED15          FIXED(15);

!   DATA='Last-Modified:'; or DATA='Expires:';  -> see caller

    CONVERT TAG_FIXED15,MONAT_FIXED15,JAHR_FIXED15
             FROM LASTMODDATE BY F(2),X,F(2),X,F(4);

    Y:=TAGNAME(TAG_FIXED15,MONAT_FIXED15,JAHR_FIXED15);
    DATA=KON(DATA,1,LEN(DATA)+1,Y,1,LEN(Y));     ! ..: day
    DATA=KON(DATA,1,LEN(DATA),', ',1,2);         ! ..: day, 
    DATA=KON(DATA,1,LEN(DATA)+1,LASTMODDATE,1,2);! ..: day, xx  
    DATA.CHAR(LEN(DATA)+1)='-';                  ! ..: day, xx-
    Y:=MONATNAME(MONAT_FIXED15);
    DATA=KON(DATA,1,LEN(DATA),Y,1,LEN(Y));       ! ..: day, xx-month  
    DATA=KON(DATA,1,LEN(DATA),'-',1,1);          ! ... day, xx-month- 
    DATA=KON(DATA,1,LEN(DATA),LASTMODDATE,7,10); ! ... day, xx-month-year  
    DATA:=KON(DATA,1,LEN(DATA)+1,LASTMODTIME,1,8); ! ... year time  
    DATA=KON(DATA,1,LEN(DATA)+1,'GMT'\0D0A\'',1,5);! ... year time GMT  

     ! VORHER GMT+2. ABER DAMIT LAESST SICH DER VERGLEICH BEI 
     ! IF-MODIFIED-SINCE NICHT DURCHFUEHREN,
     ! DA DORT IMMER DIE ZEIT IN GMT ANGEGEBEN WIRD !

    RETURN(DATA);

END; /* LAMO_EXP */ 

! *******************************************************************
! *    HEADER FGT IN DEN HTTP-KOPF DIE LAENGE DES VOM CLIENT ZU    *
! *  ERWARTENDEN DOKUMENTS EIN UND SENDET DIESEN KOPF ZUM CLIENT !  *
! *                                                                 *
! *                                                                 *
! *-----------------------------------------------------------------*
! * AUTOR : LARS SCHREINER/ all new W. Gerth                        *
! *-----------------------------------------------------------------*
! * ERSTELLT         : 29.04.1998                                   *
! * LETZTE AENDERUNG : 20.04.2000                                   *
! *******************************************************************
 
HEADER: PROC(CHILD FIXED,LAENGESTR CHAR(12) IDENT,CONTENTTYPE CHAR(255),
              METHOD_OR_ERROR FIXED IDENT,LASTMODDATE CHAR(10),
              LASTMODTIME CHAR(8));

 DCL (DATA,Y)              CHAR(255); 
 DCL NETERROR              FIXED(15)    INIT(0);
 DCL SUCHSTR               CHAR(50);
 DCL POS                   FIXED(15);
 DCL NETST                 FIXED(15);
 DCL LEN_MOR               FIXED(15);
 DCL NOT_MODIF             BIT(1);
 DCL TLEN                  FIXED(15);


 NOT_MODIF=FALSE;                           ! Asume 'modified' 

 CASE (METHOD_OR_ERROR REM 1000)

   ALT(M_BADRQ)            DATA:='HTTP/1.0 400';
   ALT(M_FNF)              DATA:='HTTP/1.0 404';
   ALT(M_GET_FNM)          DATA:='HTTP/1.0 304';
                           NOT_MODIF=TRUE;
   ALT(M_GET_N,M_GET_FMO,M_GET_AP)
                           DATA:='HTTP/1.0 200';

 FIN;

 DATA=KON(DATA,1,LEN(DATA),' Document follows'\0D0A\'MIME-Version: 1.0'\0D0A\'',1,38);
 DATA=KON(DATA,1,LEN(DATA),ServerName,1,LEN(ServerName));
 DATA=KON(DATA,1,LEN(DATA),''\0D0A\'',1,2);

 IF NOT NOT_MODIF THEN                      ! If a modified content_

     DATA=KON(DATA,1,LEN(DATA),'Content-Type: ',1,14); 
     DATA=KON(DATA,1,LEN(DATA),CONTENTTYPE,1,LEN(CONTENTTYPE));
     DATA=KON(DATA,1,LEN(DATA),''\0D0A\'Content-Length: ',1,18);
     DATA=KON(DATA,1,LEN(DATA),LAENGESTR,BEG(LAENGESTR),LEN(LAENGESTR));
     TLEN=LEN(DATA);
     DATA.CHAR(TLEN+1)=''\0D\'';
     DATA.CHAR(TLEN+2)=''\0A\'';

 FIN;    

 IF LEN(LASTMODDATE) == 0 AND LEN(LASTMODTIME) == 0 THEN  ! If both not set
    LASTMODDATE:=DATE;  
    CONVERT NOW TO LASTMODTIME BY T(8);
    Y:=LAMO_EXP('Last-Modified:',LASTMODDATE,LASTMODTIME);
    DATA=KON(DATA,1,LEN(DATA),Y,1,LEN(Y));  
    Y:=LAMO_EXP('Expires:',LASTMODDATE,LASTMODTIME);
    DATA=KON(DATA,1,LEN(DATA),Y,1,LEN(Y));  
 ELSE
    IF NOT NOT_MODIF THEN               ! If not special 3xx xfer
       Y:=LAMO_EXP('Last-Modified:',LASTMODDATE,LASTMODTIME);
       DATA=KON(DATA,1,LEN(DATA),Y,1,LEN(Y));
    FIN; ! If NOT NOT_MODIF   
 FIN; /* IF DATUM EQ '' AND ZEIT EQ '' THEN */       
   
! *******************************************************************
! *  Set a final CR+LF at the end of the file and transmit data     *
! *******************************************************************
 DATA=KON(DATA,1,LEN(DATA),''\0D0A\'',1,2); ! Separator to the HTML-Text
   
 #IF MAXILOG 
   PUT 'S: (HEADER) sending ',LEN(DATA),' bytes:'
        TO LOGLINK BY A,F(3),A;
   PUT DATA TO LOGLINK BY A(LEN(DATA));
 #FIN; 
 NETST=NETLNK(CHILD,DATA.CHAR(1),LEN(DATA),SO_WRITE,FLG_PUSH+FLG_WAIT);
 NETERROR=NETSTERR(NETST,'1'B,Alarm_out);
 IF NETERROR NE 0 THEN
    WRITE 'HTTP-USER: NETERROR in PROC HEADER !'\0D0A\'' TO Alarm_out;
    #IF MAXILOG+MINILOG
      WRITE 'S: (HEADER): NET-ERROR!' TO LOGLINK;
      NETERROR=NETSTERR(NETST,'1'B,LOGLINK);
    #FIN;
           
 FIN; /* IF NETERROR NE 0 THEN */
 
 END; /* HEADER : PROC */
 


